﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows;
using Telerik.Windows.Controls;

namespace Slider_Computation
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			this.DataContext = new MainViewModel();
		}

		public void DraSlider_OnSelectionChanged(object sender, RadRoutedEventArgs e)
		{
			var slider = sender as RadSlider;
			Debug.WriteLine(String.Format("DraSlider_OnSelectionChanged: {0}-{1}", slider.Selection.Start, slider.Selection.End));
			Debug.WriteLine(String.Format("DraSlider_OnSelectionChanged: {0}-{1}", slider.SelectionStart, slider.SelectionEnd));
		}
	}

	public class MainViewModel : ViewModelBase
	{
		private double minimum;
		private double maximum;
		private SelectionRange<double> selection;
		public MainViewModel()
		{
			this.Minimum = -200;
			this.Maximum = 200;
			this.Selection = new SelectionRange<double>(0, 100);
		}

		public double Minimum
		{
			get
			{
				return this.minimum;
			}
			set
			{
				this.minimum = value;
				this.OnPropertyChanged("Minimum");
			}
		}

		public double Maximum
		{
			get
			{
				return this.maximum;
			}
			set
			{
				this.maximum = value;
				this.OnPropertyChanged("Maximum");
			}
		}

		public SelectionRange<double> Selection
		{
			get
			{
				return this.selection;
			}
			set
			{
				this.selection = value;
				Debug.WriteLine(String.Format("Selection: {0}-{1}", value.Start, value.End));
				LongTimeOperation();
				this.OnPropertyChanged("Selection");
			}
		}

		private void LongTimeOperation()
		{
			ulong value = 0u;
			for (ulong i = 1; i < 200000000; i++)
			{
				var q = value * i + i - value / i;
			}
		}
	}
}
